//this source code was auto-generated by tolua#, do not modify it
using System;
using LuaInterface;

public class CLASSTAG_Map3DWrap
{
	public static void Register(LuaState L)
	{
		L.BeginClass(typeof(Map3D), typeof(UnityEngine.MonoBehaviour));
		L.RegFunction("Release",FUNCTAG_Release);
		L.RegFunction("LoadAsync",FUNCTAG_LoadAsync);
		L.RegFunction("GetTransferList",FUNCTAG_GetTransferList);
		L.RegFunction("GetTransferEffectParent",FUNCTAG_GetTransferEffectParent);
		L.RegFunction("World2GridPos",FUNCTAG_World2GridPos);
		L.RegFunction("IsWalkable",FUNCTAG_IsWalkable);
		L.RegFunction("IsLinePath",FUNCTAG_IsLinePath);
		L.RegFunction("GetHeight",FUNCTAG_GetHeight);
		L.RegFunction("LoadData",FUNCTAG_LoadData);
		L.RegVar("xGrid",FUNCTAG_get_xGrid, FUNCTAG_set_xGrid);
		L.RegVar("yGrid",FUNCTAG_get_yGrid, FUNCTAG_set_yGrid);
		L.RegVar("graphSize",FUNCTAG_get_graphSize, FUNCTAG_set_graphSize);
		L.RegVar("CurrentMap",FUNCTAG_get_CurrentMap, null);
		L.RegVar("mapid",FUNCTAG_get_mapid, null);
		L.RegVar("lightmapid",FUNCTAG_get_lightmapid, null);
		L.EndClass();
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_Release(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			Map3D obj = (Map3D)ToLua.CheckObject(L, 1, typeof(Map3D));
			obj.Release();
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_LoadAsync(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 5);
			Map3D obj = (Map3D)ToLua.CheckObject(L, 1, typeof(Map3D));
			int arg0 = (int)LuaDLL.luaL_checknumber(L, 2);
			int arg1 = (int)LuaDLL.luaL_checknumber(L, 3);
			bool arg2 = LuaDLL.luaL_checkboolean(L, 4);
			LuaFunction arg3 = ToLua.CheckLuaFunction(L, 5);
			obj.LoadAsync(arg0, arg1, arg2, arg3);
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_GetTransferList(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			Map3D obj = (Map3D)ToLua.CheckObject(L, 1, typeof(Map3D));
			System.Collections.Generic.List<CLASSTAG_GridMapTransferData> o = obj.GetTransferList();
			ToLua.PushObject(L, o);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_GetTransferEffectParent(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			Map3D obj = (Map3D)ToLua.CheckObject(L, 1, typeof(Map3D));
			UnityEngine.GameObject o = obj.GetTransferEffectParent();
			ToLua.Push(L, o);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_World2GridPos(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 2);
			Map3D obj = (Map3D)ToLua.CheckObject(L, 1, typeof(Map3D));
			UnityEngine.Vector3 arg0 = ToLua.ToVector3(L, 2);
			UnityEngine.Vector3 o = obj.World2GridPos(arg0);
			ToLua.Push(L, o);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_IsWalkable(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 3);
			Map3D obj = (Map3D)ToLua.CheckObject(L, 1, typeof(Map3D));
			int arg0 = (int)LuaDLL.luaL_checknumber(L, 2);
			int arg1 = (int)LuaDLL.luaL_checknumber(L, 3);
			bool o = obj.IsWalkable(arg0, arg1);
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_IsLinePath(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 3);
			Map3D obj = (Map3D)ToLua.CheckObject(L, 1, typeof(Map3D));
			UnityEngine.Vector3 arg0 = ToLua.ToVector3(L, 2);
			UnityEngine.Vector3 arg1 = ToLua.ToVector3(L, 3);
			bool o = obj.IsLinePath(arg0, arg1);
			LuaDLL.lua_pushboolean(L, o);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}
	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_LoadData(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 4);
			Map3D obj = (Map3D)ToLua.CheckObject(L, 1, typeof(Map3D));
			var arg0 = (int)LuaDLL.luaL_checknumber(L, 2);
			var arg1 = (int)LuaDLL.luaL_checknumber(L, 3);
			var arg2 = (bool)LuaDLL.luaL_checkboolean(L, 4);
			obj.LoadData(arg0, arg1, arg2);
			return 0;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_GetHeight(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 3);
			Map3D obj = (Map3D)ToLua.CheckObject(L, 1, typeof(Map3D));
			float arg0 = (float)LuaDLL.luaL_checknumber(L, 2);
			float arg1 = (float)LuaDLL.luaL_checknumber(L, 3);
			float o = obj.GetHeight(arg0, arg1);
			LuaDLL.lua_pushnumber(L, o);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_get_xGrid(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Map3D obj = (Map3D)o;
			int ret = obj.xGrid;
			LuaDLL.lua_pushinteger(L, ret);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index xGrid on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_get_yGrid(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Map3D obj = (Map3D)o;
			int ret = obj.yGrid;
			LuaDLL.lua_pushinteger(L, ret);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index yGrid on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_get_graphSize(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Map3D obj = (Map3D)o;
			float ret = obj.graphSize;
			LuaDLL.lua_pushnumber(L, ret);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index graphSize on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_get_CurrentMap(IntPtr L)
	{
		try
		{
			ToLua.Push(L, Map3D.CurrentMap);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_get_mapid(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Map3D obj = (Map3D)o;
			int ret = obj.mapid;
			LuaDLL.lua_pushinteger(L, ret);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index mapid on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_get_lightmapid(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Map3D obj = (Map3D)o;
			int ret = obj.lightmapid;
			LuaDLL.lua_pushinteger(L, ret);
			return 1;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index lightmapid on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_set_xGrid(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Map3D obj = (Map3D)o;
			int arg0 = (int)LuaDLL.luaL_checknumber(L, 2);
			obj.xGrid = arg0;
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index xGrid on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_set_yGrid(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Map3D obj = (Map3D)o;
			int arg0 = (int)LuaDLL.luaL_checknumber(L, 2);
			obj.yGrid = arg0;
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index yGrid on a nil value" : e.Message);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_set_graphSize(IntPtr L)
	{
		object o = null;

		try
		{
			o = ToLua.ToObject(L, 1);
			Map3D obj = (Map3D)o;
			float arg0 = (float)LuaDLL.luaL_checknumber(L, 2);
			obj.graphSize = arg0;
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e, o == null ? "attempt to index graphSize on a nil value" : e.Message);
		}
	}
}

